# 
# Copyright (C) 2006 F-Secure Corporation
#
# $Revision: ? $

package FS::Logger;

use strict;
use warnings;

use vars qw(@ISA @EXPORT @EXPORT_OK);

require Exporter;

@ISA = qw(Exporter);
@EXPORT = qw(debug info warning error);

my $logger = undef;

sub set_logger {
	my ($_logger) = @_;
	$logger = $_logger;	
}

sub debug   { log_message("dbg",   @_); }
sub info    { log_message("info",  @_); }
sub warning { log_message("warn",  @_); }
sub error   { log_message("error", @_); }

sub get_facility {
	my $pkg = caller(2);
	my $facility = eval "\$${pkg}::FS_Logger_facility" || "unknown";
	return $facility;
}

sub log_message {
	return unless $logger;

	my $facility = get_facility();
	my $level = shift;
	my $msg = shift;
	&$logger($level, "$facility: $msg", @_);
}

1;
